{ WinSNMP.PAS }
{ v2.0 3/16/98 }
{ Questions/comments to Bob Natale, bnatale@acecomm.com }
{ $Revision: 1.1 $ }
{ Integer is assumed to be 32 signed, Cardinal 32 bit unsigned }

unit winsnmp;

interface

uses Windows;

{ If Windows unit is not included
type
	HWND = Integer;
    UINT = Cardinal;
    WPARAM = LongInt;
    LPARAM = LongInt;
}

CONST //BY SW used for vlan create and delete.
    VLAN_STATUS_CREATEANDGO = 4;
    VLAN_STATUS_DELETE      = 6;   
type
    LPVOID = Pointer;

{ WinSNMP API Type Definitions }
type
    HSNMP_SESSION = Integer;
    LPHSNMP_SESSION  = ^HSNMP_SESSION;
    HSNMP_ENTITY = Integer;
    LPHSNMP_ENTITY = ^HSNMP_ENTITY;
    HSNMP_CONTEXT = Integer;
    LPHSNMP_CONTEXT = ^HSNMP_CONTEXT;
    HSNMP_PDU = Integer;
    LPHSNMP_PDU = ^HSNMP_PDU;
    HSNMP_VBL = Integer;
    LPHSNMP_VBL = ^HSNMP_VBL;
    smiBYTE = Byte;
    smiLPBYTE = ^smiBYTE;

{ SNMP-related types }
    smiINT = Integer;
    smiLPINT = ^smiINT;
    smiINT32 = Integer;
    smiLPINT32 = ^smiINT32;
    smiUINT32 = Cardinal;
    smiLPUINT32 = ^smiUINT32;

    smiOCTETS = record
    	len :smiUINT32;
        ptr :smiLPBYTE;
    end;
    smiLPOCTETS = ^smiOCTETS;
    smiLPCOCTETS = ^smiOCTETS;
    smiBITS = smiOCTETS;
    smiLPBITS = ^smiBITS;
    smiOID = record
    	len :smiUINT32;
        ptr :smiLPUINT32;
    end;
    smiLPOID = ^smiOID;
    smiLPCOID = ^smiOID;
    smiIPADDR = smiOCTETS;
    smiLPIPADDR = ^smiIPADDR;
    smiCNTR32 = smiUINT32;
    smiLPCNTR32 = ^smiCNTR32;
    smiGAUGE32 = smiUINT32;
    smiLPGAUGE32 = ^smiGAUGE32;
    smiTIMETICKS = smiUINT32;
    smiLPTIMETICKS = ^smiTIMETICKS;
    smiOPAQUE = smiOCTETS;
    smiLPOPAQUE = ^smiOPAQUE;
    smiNSAPADDR = smiOCTETS;
    smiLPNSAPADDR = ^smiNSAPADDR;
    smiCNTR64 = record
    	hipart, lopart :smiUINT32;
    end;
    smiLPCNTR64 = ^smiCNTR64;

{ ASN/BER Base types }
{ (used in forming SYNTAXes and certain SNMP types/value) }
const
    ASN_UNIVERSAL	= $00;
    ASN_APPLICATION	= $40;
    ASN_CONTEXT		= $80;
    ASN_PRIVATE		= $C0;
    ASN_PRIMITIVE	= $00;
    ASN_CONSTRUCTOR	= $20;

{* SNMP ObjectSyntax Values }
	SNMP_SYNTAX_SEQUENCE  = (ASN_UNIVERSAL or ASN_CONSTRUCTOR or $10);
{ These values are used in the "syntax" member of the smiVALUE structure which follows *}
	SNMP_SYNTAX_INT       = (ASN_UNIVERSAL or ASN_PRIMITIVE or $02);  //2
	SNMP_SYNTAX_BITS      = (ASN_UNIVERSAL or ASN_PRIMITIVE or $03);  //3
	SNMP_SYNTAX_OCTETS    = (ASN_UNIVERSAL or ASN_PRIMITIVE or $04);  //4
	SNMP_SYNTAX_NULL      = (ASN_UNIVERSAL or ASN_PRIMITIVE or $05);  //5
	SNMP_SYNTAX_OID       = (ASN_UNIVERSAL or ASN_PRIMITIVE or $06);  //6
	SNMP_SYNTAX_INT32     = SNMP_SYNTAX_INT;                          //2
	SNMP_SYNTAX_IPADDR    = (ASN_APPLICATION or ASN_PRIMITIVE or $00);//64
	SNMP_SYNTAX_CNTR32    = (ASN_APPLICATION or ASN_PRIMITIVE or $01);//65
	SNMP_SYNTAX_GAUGE32   = (ASN_APPLICATION or ASN_PRIMITIVE or $02);//66
	SNMP_SYNTAX_TIMETICKS = (ASN_APPLICATION or ASN_PRIMITIVE or $03);//67
	SNMP_SYNTAX_OPAQUE    = (ASN_APPLICATION or ASN_PRIMITIVE or $04);//68
	SNMP_SYNTAX_NSAPADDR  = (ASN_APPLICATION or ASN_PRIMITIVE or $05);//69
	SNMP_SYNTAX_CNTR64    = (ASN_APPLICATION or ASN_PRIMITIVE or $06);//70
	SNMP_SYNTAX_UINT32    = (ASN_APPLICATION or ASN_PRIMITIVE or $07);//71
{ Exception conditions in response PDUs for SNMPv2 }
	SNMP_SYNTAX_NOSUCHOBJECT   = (ASN_CONTEXT or ASN_PRIMITIVE or $00);
	SNMP_SYNTAX_NOSUCHINSTANCE = (ASN_CONTEXT or ASN_PRIMITIVE or $01);
	SNMP_SYNTAX_ENDOFMIBVIEW   = (ASN_CONTEXT or ASN_PRIMITIVE or $02);

type
	smiVALUE = record		{ smiVALUE portion of VarBind }
    	syntax : smiUINT32;      	{ Insert SNMP_SYNTAX_<type> }
        value : record
	    	case Integer of
    	    	SNMP_SYNTAX_INT       :(sNumber :smiINT);	{ SNMP_SYNTAX_INT }

                SNMP_SYNTAX_UINT32,
                SNMP_SYNTAX_CNTR32,
                SNMP_SYNTAX_GAUGE32,
                SNMP_SYNTAX_TIMETICKS :(uNumber :smiUINT32);	{ SNMP_SYNTAX_UINT32 }

                SNMP_SYNTAX_CNTR64    :(hNumber :smiCNTR64);	{ SNMP_SYNTAX_CNTR64 }

                SNMP_SYNTAX_OCTETS,
                SNMP_SYNTAX_BITS,
                SNMP_SYNTAX_OPAQUE,
                SNMP_SYNTAX_NSAPADDR  :(sstring :smiOCTETS);	{ SNMP_SYNTAX_OCTETS }

                SNMP_SYNTAX_OID        :(oid :smiOID);	{ SNMP_SYNTAX_OID }

                SNMP_SYNTAX_NULL,
                SNMP_SYNTAX_NOSUCHOBJECT,
                SNMP_SYNTAX_NOSUCHINSTANCE,
                SNMP_SYNTAX_ENDOFMIBVIEW :(empty:smiBYTE);	{ SNMP_SYNTAX_NULL }
        end;
    end;
    smiLPVALUE = ^smiVALUE;
    smiLPCVALUE = ^smiVALUE;

{ SNMP Limits }
const
	MAXOBJIDSIZE = 128;  	{ Max number of components in an OID }
	MAXOBJIDSTRSIZE = 1408; { Max len of decoded MAXOBJIDSIZE OID }

{ PDU Type Values }
	SNMP_PDU_GET          = (ASN_CONTEXT or ASN_CONSTRUCTOR or $0);
	SNMP_PDU_GETNEXT      = (ASN_CONTEXT or ASN_CONSTRUCTOR or $1);
	SNMP_PDU_RESPONSE     = (ASN_CONTEXT or ASN_CONSTRUCTOR or $2);
	SNMP_PDU_SET          = (ASN_CONTEXT or ASN_CONSTRUCTOR or $3);
{ SNMP_PDU_V1TRAP is obsolete in SNMPv2 }
	SNMP_PDU_V1TRAP       = (ASN_CONTEXT or ASN_CONSTRUCTOR or $4);
	SNMP_PDU_GETBULK      = (ASN_CONTEXT or ASN_CONSTRUCTOR or $5);
	SNMP_PDU_INFORM       = (ASN_CONTEXT or ASN_CONSTRUCTOR or $6);
	SNMP_PDU_TRAP         = (ASN_CONTEXT or ASN_CONSTRUCTOR or $7);

{ SNMPv1 Trap Values }
{ (These values might be superfluous wrt WinSNMP applications) }
	SNMP_TRAP_COLDSTART             = 0;
	SNMP_TRAP_WARMSTART             = 1;
	SNMP_TRAP_LINKDOWN              = 2;
	SNMP_TRAP_LINKUP                = 3;
	SNMP_TRAP_AUTHFAIL              = 4;
	SNMP_TRAP_EGPNEIGHBORLOSS       = 5;
	SNMP_TRAP_ENTERPRISESPECIFIC    = 6;

{ SNMP Error Codes Returned in Error_status Field of PDU }
{ (these are NOT WinSNMP API Error Codes) }
{ Error Codes Common to SNMPv1 and SNMPv2 }
	SNMP_ERROR_NOERROR              = 0;
	SNMP_ERROR_TOOBIG               = 1;
	SNMP_ERROR_NOSUCHNAME           = 2;
	SNMP_ERROR_BADVALUE             = 3;
	SNMP_ERROR_READONLY             = 4;
	SNMP_ERROR_GENERR               = 5;
{ Error Codes Added for SNMPv2 }
	SNMP_ERROR_NOACCESS             = 6;
	SNMP_ERROR_WRONGTYPE            = 7;
	SNMP_ERROR_WRONGLENGTH          = 8;
	SNMP_ERROR_WRONGENCODING        = 9;
	SNMP_ERROR_WRONGVALUE           = 10;
	SNMP_ERROR_NOCREATION           = 11;
	SNMP_ERROR_INCONSISTENTVALUE    = 12;
	SNMP_ERROR_RESOURCEUNAVAILABLE  = 13;
	SNMP_ERROR_COMMITFAILED         = 14;
	SNMP_ERROR_UNDOFAILED           = 15;
	SNMP_ERROR_AUTHORIZATIONERROR   = 16;
	SNMP_ERROR_NOTWRITABLE          = 17;
	SNMP_ERROR_INCONSISTENTNAME     = 18;

{ WinSNMP API Values }
{ Values used to indicate entity/context translation modes }
	SNMPAPI_TRANSLATED         = 0;
	SNMPAPI_UNTRANSLATED_V1    = 1;
	SNMPAPI_UNTRANSLATED_V2    = 2;

{ Values used to indicate "SNMP level" supported by the implementation }
	SNMPAPI_NO_SUPPORT         = 0;
	SNMPAPI_V1_SUPPORT         = 1;
	SNMPAPI_V2_SUPPORT         = 2;
	SNMPAPI_M2M_SUPPORT        = 3;

{ Values used to indicate retransmit mode in the implementation }
	SNMPAPI_OFF                = 0;    { Refuse support }
	SNMPAPI_ON                 = 1;    { Request support }

{ WinSNMP API Function Return Codes }
type
	SNMPAPI_STATUS = smiUINT32;		   { Used for function ret values }

const
	SNMPAPI_FAILURE            = 0;    { Generic error code }
	SNMPAPI_SUCCESS            = 1;    { Generic success code }


{ WinSNMP API Error Codes (for SnmpGetLastError) }
{ (NOT SNMP Response-PDU error_status codes) }
const
	SNMPAPI_ALLOC_ERROR        = 2;    { Error allocating memory }
	SNMPAPI_CONTEXT_INVALID    = 3;    { Invalid context parameter }
	SNMPAPI_CONTEXT_UNKNOWN    = 4;    { Unknown context parameter }
	SNMPAPI_ENTITY_INVALID     = 5;    { Invalid entity parameter }
	SNMPAPI_ENTITY_UNKNOWN     = 6;    { Unknown entity parameter }
	SNMPAPI_INDEX_INVALID      = 7;    { Invalid VBL index parameter }
	SNMPAPI_NOOP               = 8;    { No operation performed }
	SNMPAPI_OID_INVALID        = 9;    { Invalid OID parameter }
	SNMPAPI_OPERATION_INVALID  = 10;   { Invalid/unsupported operation }
	SNMPAPI_OUTPUT_TRUNCATED   = 11;   { Insufficient output buf len }
	SNMPAPI_PDU_INVALID        = 12;   { Invalid PDU parameter }
	SNMPAPI_SESSION_INVALID    = 13;   { Invalid session parameter }
	SNMPAPI_SYNTAX_INVALID     = 14;   { Invalid syntax in smiVALUE }
	SNMPAPI_VBL_INVALID        = 15;   { Invalid VBL parameter }
	SNMPAPI_MODE_INVALID       = 16;   { Invalid mode parameter }
	SNMPAPI_SIZE_INVALID       = 17;   { Invalid size/length parameter }
	SNMPAPI_NOT_INITIALIZED    = 18;   { SnmpStartup failed/not called }
	SNMPAPI_MESSAGE_INVALID    = 19;   { Invalid SNMP message format }
	SNMPAPI_HWND_INVALID       = 20;   { Invalid Window handle }
	SNMPAPI_OTHER_ERROR        = 99;   { For internal/undefined errors }
{ Generic Transport Layer (TL) Errors }
	SNMPAPI_TL_NOT_INITIALIZED = 100;  { TL not initialized }
	SNMPAPI_TL_NOT_SUPPORTED   = 101;  { TL does not support protocol }
	SNMPAPI_TL_NOT_AVAILABLE   = 102;  { Network subsystem has failed }
	SNMPAPI_TL_RESOURCE_ERROR  = 103;  { TL resource error }
	SNMPAPI_TL_UNDELIVERABLE   = 104;  { Destination unreachable }
	SNMPAPI_TL_SRC_INVALID     = 105;  { Source endpoint invalid }
	SNMPAPI_TL_INVALID_PARAM   = 106;  { Input parameter invalid }
	SNMPAPI_TL_IN_USE          = 107;  { Source endpoint in use }
	SNMPAPI_TL_TIMEOUT         = 108;  { No response before timeout }
	SNMPAPI_TL_PDU_TOO_BIG     = 109;  { PDU too big for send/receive }
	SNMPAPI_TL_OTHER           = 199;  { Undefined TL error }

{ WinSNMP API Function Prototypes }
{ v2.0: Structure for SnmpGetVendorInfo() output }

const
	MAXVENDORINFO = 32;

type
	smiVENDORINFO = record
		vendorName :array [0..MAXVENDORINFO*2-1] of CHAR;
		vendorContact :array [0..MAXVENDORINFO*2-1] of CHAR;
		vendorVersionId :array [0..MAXVENDORINFO-1] of CHAR;
		vendorVersionDate :array [0..MAXVENDORINFO-1] of CHAR;
		vendorEnterprise :smiUINT32;
    end;
	smiLPVENDORINFO = ^smiVENDORINFO;

{ v2.0: Callback format for SnmpCreateSession() fCallback parameter }
{ Declare the callback like
  function SnmpCallback(hSession:HSNMP_SESSION; hWnd: HWND;
  						wMsg: UINT; wParam:WPARAM,
                        lParam: LPARAM; lClientpData :LPVOID)
                        : SNMPAPI_STATUS; stdcall;
}

type
	SNMPAPI_CALLBACK = Pointer;

{ Local Database Functions }
function SnmpGetTranslateMode
		(nTranslateMode :smiLPUINT32): SNMPAPI_STATUS; stdcall;

function SnmpSetTranslateMode
		(nTranslateMode :smiUINT32): SNMPAPI_STATUS; stdcall;

function SnmpGetRetransmitMode
        (nRetransmitMode :smiLPUINT32): SNMPAPI_STATUS; stdcall;

function SnmpSetRetransmitMode
        (nRetransmitMode :smiUINT32): SNMPAPI_STATUS; stdcall;

function SnmpGetTimeout
        (hEntity :HSNMP_ENTITY;
        nPolicyTimeout :smiLPTIMETICKS;
        nActualTimeout :smiLPTIMETICKS): SNMPAPI_STATUS; stdcall;

function SnmpSetTimeout
        (hEntity :HSNMP_ENTITY;
        nPolicyTimeout :smiTIMETICKS): SNMPAPI_STATUS; stdcall;

function SnmpGetRetry
        (hEntity :HSNMP_ENTITY;
        nPolicyRetry :smiLPUINT32;
        nActualRetry :smiLPUINT32): SNMPAPI_STATUS; stdcall;

function SnmpSetRetry
        (hEntity :HSNMP_ENTITY;
        nPolicyRetry :smiUINT32): SNMPAPI_STATUS; stdcall;

{ Following Local Database Functions added in v2.0 }
function SnmpGetVendorInfo
        (vendorInfo :smiLPVENDORINFO): SNMPAPI_STATUS; stdcall;

{ Communications Functions }
function SnmpStartup
        (nMajorVersion :smiLPUINT32;
        nMinorVersion :smiLPUINT32;
        nLevel :smiLPUINT32;
        nTranslateMode :smiLPUINT32;
        nRetransmitMode :smiLPUINT32): SNMPAPI_STATUS; stdcall;

function SnmpCleanup
        : SNMPAPI_STATUS; stdcall;

function SnmpOpen
        (hWnd :HWND;
        wMsg :UINT): HSNMP_SESSION; stdcall;

function SnmpClose
        (session :HSNMP_SESSION): SNMPAPI_STATUS; stdcall;

function SnmpSendMsg
        (session :HSNMP_SESSION;
        srcEntity :HSNMP_ENTITY;
        dstEntity :HSNMP_ENTITY;
        context :HSNMP_CONTEXT;
        PDU :HSNMP_PDU): SNMPAPI_STATUS; stdcall;

function SnmpRecvMsg
		(session :HSNMP_SESSION;
        srcEntity :LPHSNMP_ENTITY;
        dstEntity :LPHSNMP_ENTITY;
        context :LPHSNMP_CONTEXT;
        PDU :LPHSNMP_PDU): SNMPAPI_STATUS; stdcall;

function SnmpRegister
        (session :HSNMP_SESSION;
        srcEntity :HSNMP_ENTITY;
        dstEntity :HSNMP_ENTITY;
        context :HSNMP_CONTEXT;
        notification :smiLPCOID;
        state :smiUINT32): SNMPAPI_STATUS; stdcall;

{ Following Communications Functions added in v2.0 }
function SnmpCreateSession
        (hWnd :HWND;
        wMsg :UINT;
        fCallBack :SNMPAPI_CALLBACK;
        lpClientData :LPVOID): SNMPAPI_STATUS; stdcall;

function SnmpListen
        (hEntity :HSNMP_ENTITY;
        lStatus :SNMPAPI_STATUS): SNMPAPI_STATUS; stdcall;

function SnmpCancelMsg
        (session :HSNMP_SESSION;
        reqId :smiINT32): SNMPAPI_STATUS; stdcall;

{ Entity/Context Functions }
function SnmpStrToEntity
        (session :HSNMP_SESSION;
        sstring :LPCSTR): HSNMP_ENTITY; stdcall;

function SnmpEntityToStr
        (entity :HSNMP_ENTITY;
        size :smiUINT32;
        sstring :LPSTR): SNMPAPI_STATUS; stdcall;

function SnmpFreeEntity
        (entity :HSNMP_ENTITY): SNMPAPI_STATUS; stdcall;

function SnmpStrToContext
        (session :HSNMP_SESSION;
        sstring :smiLPCOCTETS): HSNMP_CONTEXT; stdcall;

function SnmpContextToStr
        (context :HSNMP_CONTEXT;
        sstring :smiLPOCTETS): SNMPAPI_STATUS; stdcall;

function SnmpFreeContext
        (context :HSNMP_CONTEXT): SNMPAPI_STATUS; stdcall;

{ Following Entity/Context Functions added in v2.0 }
function SnmpSetPort
        (hEntity :HSNMP_ENTITY;
        nPort :UINT): SNMPAPI_STATUS; stdcall;

{ PDU Functions }
function SnmpCreatePdu
        (session :HSNMP_SESSION;
        PDU_type :smiINT;
        request_id :smiINT32;
        error_status :smiINT;
        error_index :smiINT;
        varbindlist :HSNMP_VBL): HSNMP_PDU; stdcall;

function SnmpGetPduData
        (PDU :HSNMP_PDU;
        PDU_type :smiLPINT;
        request_id :smiLPINT32;
        error_status :smiLPINT;
        error_index :smiLPINT;
        varbindlist :LPHSNMP_VBL): SNMPAPI_STATUS; stdcall;

function SnmpSetPduData
        (PDU :HSNMP_PDU;
        PDU_type: smiLPINT;
        request_id: smiLPINT32;
        non_repeaters: smiLPINT;
        max_repetitions: smiLPINT;
        varbindlist: LPHSNMP_VBL): SNMPAPI_STATUS; stdcall;

function SnmpDuplicatePdu
        (session :HSNMP_SESSION;
        PDU :HSNMP_PDU): HSNMP_PDU; stdcall;

function SnmpFreePdu
        (PDU :HSNMP_PDU): SNMPAPI_STATUS; stdcall;

{ Variable-Binding Functions }
function SnmpCreateVbl
        (session :HSNMP_SESSION;
        name :smiLPCOID;
        value :smiLPCVALUE): HSNMP_VBL; stdcall;

function SnmpDuplicateVbl
        (session :HSNMP_SESSION;
        vbl :HSNMP_VBL): HSNMP_VBL; stdcall;

function SnmpFreeVbl
        (vbl :HSNMP_VBL): SNMPAPI_STATUS; stdcall;

function SnmpCountVbl
        (vbl :HSNMP_VBL): SNMPAPI_STATUS; stdcall;

function SnmpGetVb
        (vbl :HSNMP_VBL;
        index :smiUINT32;
        name :smiLPOID;
        value :smiLPVALUE): SNMPAPI_STATUS; stdcall;

function SnmpSetVb
        (vbl :HSNMP_VBL;
        index :smiUINT32;
        name :smiLPCOID;
        value :smiLPCVALUE): SNMPAPI_STATUS; stdcall;

function SnmpDeleteVb
        (vbl :HSNMP_VBL;
        index :smiUINT32): SNMPAPI_STATUS; stdcall;

{ Utility Functions }
function SnmpGetLastError
        (session :HSNMP_SESSION): SNMPAPI_STATUS; stdcall;

function SnmpStrToOid
        (sstring :LPCSTR;
        dstOID :smiLPOID): SNMPAPI_STATUS; stdcall;

function SnmpOidToStr
        (srcOID :smiLPCOID;
        size :smiUINT32;
        sstring :LPSTR): SNMPAPI_STATUS; stdcall;

function SnmpOidCopy
        (srcOID :smiLPCOID;
        dstOID :smiLPOID): SNMPAPI_STATUS; stdcall;

function SnmpOidCompare
        (xOID :smiLPCOID;
        yOID :smiLPCOID;
        maxlen :smiUINT32;
        result :smiLPINT): SNMPAPI_STATUS; stdcall;

function SnmpEncodeMsg
        (session :HSNMP_SESSION;
        srcEntity :HSNMP_ENTITY;
        dstEntity :HSNMP_ENTITY;
        context :HSNMP_CONTEXT;
        pdu :HSNMP_PDU;
        msgBufDesc :smiLPOCTETS): SNMPAPI_STATUS; stdcall;

function SnmpDecodeMsg
        (session :HSNMP_SESSION;
        srcEntity :LPHSNMP_ENTITY;
        dstEntity :LPHSNMP_ENTITY;
        context :LPHSNMP_CONTEXT;
        pdu :LPHSNMP_PDU;
        msgBufDesc :smiLPCOCTETS): SNMPAPI_STATUS; stdcall;

function SnmpFreeDescriptor
        (syntax :smiUINT32;
        descriptor :smiLPOPAQUE): SNMPAPI_STATUS; stdcall;

const
	wsnmp32 = 'wsnmp32.dll';

implementation

function SnmpGetTranslateMode; external wsnmp32 name 'SnmpGetTranslateMode';
function SnmpSetTranslateMode; external wsnmp32 name 'SnmpSetTranslateMode';
function SnmpGetRetransmitMode; external wsnmp32 name 'SnmpGetRetransmitMode';
function SnmpSetRetransmitMode; external wsnmp32 name 'SnmpSetRetransmitMode';
function SnmpGetTimeout; external wsnmp32 name 'SnmpGetTimeout';
function SnmpSetTimeout; external wsnmp32 name 'SnmpSetTimeout';
function SnmpGetRetry; external wsnmp32 name 'SnmpGetRetry';
function SnmpSetRetry; external wsnmp32 name 'SnmpSetRetry';
function SnmpGetVendorInfo; external wsnmp32 name 'SnmpGetVendorInfo';
function SnmpStartup; external wsnmp32 name 'SnmpStartup';
function SnmpCleanup; external wsnmp32 name 'SnmpCleanup';
function SnmpOpen; external wsnmp32 name 'SnmpOpen';
function SnmpClose; external wsnmp32 name 'SnmpClose';
function SnmpSendMsg; external wsnmp32 name 'SnmpSendMsg';
function SnmpRecvMsg; external wsnmp32 name 'SnmpRecvMsg';
function SnmpRegister; external wsnmp32 name 'SnmpRegister';
function SnmpCreateSession; external wsnmp32 name 'SnmpCreateSession';
function SnmpListen; external wsnmp32 name 'SnmpListen';
function SnmpCancelMsg; external wsnmp32 name 'SnmpCancelMsg';
function SnmpStrToEntity; external wsnmp32 name 'SnmpStrToEntity';
function SnmpEntityToStr; external wsnmp32 name 'SnmpEntityToStr';
function SnmpFreeEntity; external wsnmp32 name 'SnmpFreeEntity';
function SnmpSetPort; external wsnmp32 name 'SnmpSetPort';
function SnmpStrToContext; external wsnmp32 name 'SnmpStrToContext';
function SnmpContextToStr; external wsnmp32 name 'SnmpContextToStr';
function SnmpFreeContext; external wsnmp32 name 'SnmpFreeContext';
function SnmpCreatePdu; external wsnmp32 name 'SnmpCreatePdu';
function SnmpGetPduData; external wsnmp32 name 'SnmpGetPduData';
function SnmpSetPduData; external wsnmp32 name 'SnmpSetPduData';
function SnmpDuplicatePdu; external wsnmp32 name 'SnmpDuplicatePdu';
function SnmpFreePdu; external wsnmp32 name 'SnmpFreePdu';
function SnmpCreateVbl; external wsnmp32 name 'SnmpCreateVbl';
function SnmpDuplicateVbl; external wsnmp32 name 'SnmpDuplicateVbl';
function SnmpFreeVbl; external wsnmp32 name 'SnmpFreeVbl';
function SnmpCountVbl; external wsnmp32 name 'SnmpCountVbl';
function SnmpGetVb; external wsnmp32 name 'SnmpGetVb';
function SnmpSetVb; external wsnmp32 name 'SnmpSetVb';
function SnmpDeleteVb; external wsnmp32 name 'SnmpDeleteVb';
function SnmpFreeDescriptor; external wsnmp32 name 'SnmpFreeDescriptor';
function SnmpEncodeMsg; external wsnmp32 name 'SnmpEncodeMsg';
function SnmpDecodeMsg; external wsnmp32 name 'SnmpDecodeMsg';
function SnmpStrToOid; external wsnmp32 name 'SnmpStrToOid';
function SnmpOidToStr; external wsnmp32 name 'SnmpOidToStr';
function SnmpOidCopy; external wsnmp32 name 'SnmpOidCopy';
function SnmpOidCompare; external wsnmp32 name 'SnmpOidCompare';
function SnmpGetLastError; external wsnmp32 name 'SnmpGetLastError';
end.




